OPT OSVERSION=37

MODULE 'superplay',
       'libraries/superplay',
       '*super_rev'

DEF err,handle:PTR TO LONG
PROC main() HANDLE
   checkarg()
   openlibs()
   play()
   domenu()
   eject(NIL)
EXCEPT DO
SELECT exception
  DEFAULT
     eject('Unkown error!')
ENDSELECT
ENDPROC

PROC usage()
   eject('Usage: supEr <filename>')
   CleanUp(0)
ENDPROC

PROC closenkill(base)
   IF base THEN CloseLibrary(base)
   IF base THEN base:=0
ENDPROC

PROC eject(errstr)
DEF dummy
   IF handle THEN SpL_FreeHandle(handle)
   IF superplaybase THEN closenkill(superplaybase)
   IF errstr THEN dummy:=msg(errstr,NIL,'CLI-Tracker Error')
   CleanUp(0)
ENDPROC

PROC msg(msgstring,buttxt=NIL,header=NIL)
DEF dummy
   dummy:=EasyRequestArgs(0,[20,0,IF header THEN header ELSE 'CLI-Tracker Request',msgstring,IF buttxt THEN buttxt ELSE ' OK '],0,NIL)
ENDPROC dummy

PROC play()
   SpL_InitHandleAsDOS(handle,NIL) /* Please note: SpL NOT SPL !!! */
   IF (err:=SpL_SuperPlay(handle,arg))<>NIL THEN eject(SpL_GetErrorString(err))
ENDPROC

PROC openlibs()
   IF (superplaybase:=OpenLibrary('superplay.library',6))=0 THEN eject('Could not open superplay.library v6')
   IF (handle:=SpL_AllocHandle(NIL))=NIL THEN eject('Could not allocate handle')
ENDPROC

PROC checkarg()
   IF StrCmp(arg,'?',ALL) THEN usage()
ENDPROC

PROC domenu()
   PrintF('\nsupEr \d.\d  Frits Letteboer <dagraver@dds.nl> \nThis is an example how to use Superplay.library in AmigaE\n\n',VERSION,REVISION)
   PrintF('\nsupEr is now playing "\s"...\n\nPress CTRL-C to quit',FilePart(arg))
   REPEAT
   Delay(100)
   UNTIL CtrlC()
   PrintF('\n')
ENDPROC


