OPT OSVERSION=37

MODULE 'superplay',
       'libraries/superplay',
       '*super_rev',
       'tools/easygui_lite',
       'tools/exceptions'

DEF err,handle:PTR TO LONG
PROC main() HANDLE
   checkarg()
   openlibs()
   play()
   domenu()
   eject(NIL)
EXCEPT DO
SELECT exception
CASE "bigg"
     eject('GUI too big for current screen!!!')
CASE "MEM"
     eject('Insufficient memory to open GUI!!!')
CASE "GT"
     eject('Could not open gadtools.library!!!')
CASE "Egui"
     eject('Error while creating GUI!!!')
CASE "GUI"
     eject('Error while displaying GUI!!!')
DEFAULT
     report_exception()
     eject('Unkown error!')
ENDSELECT
ENDPROC

PROC usage()
   eject('Usage: supEr <filename>')
   CleanUp(0)
ENDPROC

PROC closenkill(base)
   IF base THEN CloseLibrary(base)
ENDPROC

PROC eject(errstr)
DEF dummy
   IF handle THEN SpL_FreeHandle(handle)
   IF superplaybase THEN closenkill(superplaybase)
   IF errstr THEN dummy:=msg(errstr,NIL,'CLI-Tracker Error')
   CleanUp(0)
ENDPROC

PROC msg(msgstring,buttxt=NIL,header=NIL)
DEF dummy
   dummy:=EasyRequestArgs(0,[20,0,IF header THEN header ELSE 'CLI-Tracker Request',msgstring,IF buttxt THEN buttxt ELSE ' OK '],0,NIL)
ENDPROC dummy

PROC play()
   SpL_InitHandleAsDOS(handle,NIL) /* Please note: SpL NOT SPL !!! */
   IF (err:=SpL_SuperPlay(handle,arg))<>NIL THEN eject(SpL_GetErrorString(err))
ENDPROC

PROC openlibs()
   IF (superplaybase:=OpenLibrary('superplay.library',6))=0 THEN eject('Could not open superplay.library v6')
   IF (handle:=SpL_AllocHandle(NIL))=NIL THEN eject('Could not allocate handle')
ENDPROC

PROC checkarg()
   IF StrCmp(arg,'?',ALL) THEN usage()
ENDPROC

PROC domenu()
DEF str_title[50]:STRING,str_filename[50]:STRING,str_size[50]:STRING
   /* Init some strings */
   StringF(str_title,'supEr \d.\d (\d.\d.\d)',VERSION,REVISION,VERSION_DAY,VERSION_MONTH,VERSION_YEAR)
   StringF(str_filename,'\s',FilePart(arg))
   StringF(str_size,'\d',FileLength(arg))

   /* Menu layout */

   easyguiA(str_title,
            [BEVEL,
              [ROWS,
                [TEXT,'      1997 Frits Letteboer     ',NIL,TRUE,0],
                [SPACEH],
                [TEXT,str_filename,' Filename  :',TRUE,0],
                [TEXT,str_size,' Filesize  :',TRUE,0]
             ]
            ])
ENDPROC


