/* ======================================================================== */
/* = Programmname    : ListSPOs_Subs V7.1                                 = */
/* =                                                                      = */
/* ======================================================================== */
/* = Autor/Copyright : (c) 1990-97 by Andreas Ralph Kleinert.             = */
/* =                   All rights reserved.                               = */
/* ======================================================================== */
/* = Funktion        : Sub-Routines for SimplePlay V7.1                   = */
/* =                                                                      = */
/* ======================================================================== */
/* = Compiler        : SAS/C V6.57                                        = */
/* =                                                                      = */
/* ======================================================================== */

#define __USE_SYSBASE

#include <exec/types.h>
#include <exec/memory.h>

#include <proto/exec.h>
#include <proto/dos.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define N (NULL) /* as usual */


void __stdargs SP_Printf(char *formatstring, ...);


/* *************************************************** */
/* *                                                 * */
/* * SP_Printf : Replacement for printf()-Output     * */
/* *                                                 * */
/* *************************************************** */

#define KIP_BUFLEN (1200)

ULONG Fmt = (ULONG) 0x16c04e75;

void __stdargs SP_Printf(char *formatstring, ...)
{
 UBYTE *buffer;

 buffer = (BYTE *) AllocVec(KIP_BUFLEN, MEMF_CLEAR);
 if(buffer)
  {
   RawDoFmt((APTR) formatstring, (APTR) (((ULONG *)&formatstring)+1), (APTR) &Fmt, (APTR) buffer);

   Write(Output(), buffer, strlen(buffer));

   FreeVec(buffer);
  }
}
